// 监听dev目录 编译 到work目录
const arg = process.argv;
const fs = require('fs');
const path = require('path');
const spiht = require('../plug-in/spiht');
const watch = require('../plug-in/watch');
const exist = require('../plug-in/exist');
var conf = require(paths('package.json'));
const work = conf.fk2.dir;
if (!fs.existsSync(paths(work))) {
    // 判断工作目录是否存在文件
    fs.mkdirSync(paths(work));
}
const logs = require('../plug-in/colorLog');
const addJSON = require('../plug-in/addJSON');
const arrs = [paths(work), paths('node_modules')];
readdir(paths(), funct);
if (arg[3]) {
    if (exist(conf.fk2.dir+'/' + arg[3])) {
        require('./cluster')
    }
} else {
    logs.g('\nFk2 Dev began to working ... \n');
    logs.y('Dev running directory is ' + paths(work) + '\n');
    logs.close();
}
function paths(url) {
    return path.join(process.cwd(), url ? url : '')
}
function funct(d) {
    // 收到指令
    const urls = d.url.replace(paths(), paths(work));
    if (d.type == 'del') {
        // 删除
        try {
            //删除文件
            fs.unlinkSync(urls);
        } catch (e) {
            //删除文件夹
            emptyDir(urls);
        }
    } else {
        // 编辑文件
        if (d.file == true) {
            copyFileSync(d.url, urls);
        } else {
            if (!fs.existsSync(urls)) {
                // 判断工作目录是否存在文件
                mkdirSync(d.url, urls);
            }
        }
    }
}
function copyFileSync(url, urls) {
    // 复制文件
    if (url == paths('package.json')) {
        return
    }
    conf.fk2.time = new Date().getTime();
    addJSON(paths('package.json'), conf);
    const ext = path.extname(url).toLowerCase().replace('.', '');
    setTimeout(() => {
        try {
            if (!conf.fk2.ext.includes(ext)) {
                fs.copyFileSync(url, urls);
            } else {
                // 开启压缩模式
                const data = spiht(url);
                fs.writeFileSync(urls, data);

            }
        } catch (e) {

        }

    }, 500);
}
function mkdirSync(url, urls) {
    // 判断工作目录是否存在 添加子文件夹要加监听
    if (arrs.includes(url)) {
        return;
    }
    try {
        watch(url, funct);
        fs.mkdirSync(urls);
    } catch (e) {
        console.log(e);
        return
    }
    addAll(url);// 添加文件夹或文件
}
function addAll(url, obj) {
    // 添加文件夹或文件
    const files = fs.readdirSync(url);
    files.forEach(file => {
        const filePath = `${url}\\${file}`;
        const filePaths = filePath.replace(paths(), paths(work));
        const stats = fs.statSync(filePath);
        if (stats.isDirectory()) {
            // 目录
            addAll(filePath);
        } else {
            // 文件
            if (obj == true) return;
            copyFileSync(filePath, filePaths);
        }
    });
}

function readdir(url) {
    watch(url, funct); //监听总目录
    watchDir(url);// 循环监听
    fkdirSync(url.replace(paths(), paths(work)));
}
function watchDir(url) {
    // 监听文件夹
    const files = fs.readdirSync(url);
    files.forEach(file => {
        const filePath = `${url}\\${file}`;
        const stats = fs.statSync(filePath);
        const filePaths = filePath.replace(paths(), paths(work));
        if (stats.isDirectory()) {
            // 是文件夹 监听子文件夹
            if (file !== work && file !== 'node_modules') {
                if (!fs.existsSync(filePaths)) {
                    // 同步文件夹
                    fs.mkdirSync(filePaths);
                }
                watch(filePath, funct);
                addAll(filePath, true);
                watchDir(filePath);
            }
        } else {
            if (!fs.existsSync(filePaths)) {
                // 同步文件
                copyFileSync(filePath, filePaths);
            }
        }
    });
}
function emptyDir(path) {
    // 清空文件夹和文件
    var files = [];
    try {
        files = fs.readdirSync(path);
    } catch (error) {
        return
    }
    files.forEach(file => {
        const filePath = `${path}/${file}`;
        const stats = fs.statSync(filePath);
        if (stats.isDirectory()) {
            emptyDir(filePath);
        } else {
            try {
                fs.unlinkSync(filePath);
            } catch (error) {

            }
        }
    });
    fs.rmdirSync(path);
}
function fkdirSync(url) {
    // 反向同步 删除多余的备份文件
    const files = fs.readdirSync(url);
    files.forEach(file => {
        const filePath = `${url}\\${file}`; //work路径
        const filePaths = filePath.replace(paths(work), paths());
        const stats = fs.statSync(filePath);
        if (stats.isDirectory()) {
            // 是文件夹
            fkdirSync(filePath);
            if (!fs.existsSync(filePaths)) {
                // 源文件夹不存在时删除
                emptyDir(filePath);
            }
        } else {
            if (!fs.existsSync(filePaths)) {
                // 源文件不存在时删除
                fs.unlinkSync(filePath);
            }
        }
    });
}