const {v1} = require("rrid");
module.exports = (req)=>{
    var obj = {};
    obj.id = v1();
    obj.ip = getIP(req);
    obj.data = req.body;
    obj.headers = req.headers;
    obj.url = req.originalUrl.split("?")[0];
    return obj
}
function getIP(req) {
    // 支持ipv4 和ipv6
    var ips = req.headers['x-forwarded-for'] ||
    req.connection.remoteAddress ||
    req.socket.remoteAddress ||
    req.connection.socket.remoteAddress || '';
    ips = ips.replace('%9','');
    var ip = ips.match(/\d+.\d+.\d+.\d+/);
    ip = ip?ip.join('.') : null;
    if(ip&&ip.match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)){
        return ip
    }else{
        return ips
    }
}