const ps = require('ps-node');
module.exports = {
    kill(pid){
        return new Promise((resolve) => {
            console.log('Trying to close the process ...');
            ps.kill(pid, ( err )=> {
                if (err) {
                    resolve(false)
                } else {
                    console.log( 'Process %s has been killed!', pid );
                    resolve(true)
                }
            });
        })
    },
    check(pid){
        return new Promise((resolve) => {
            ps.lookup({pid,command: 'node'}, (err, rList )=> {
                if (err) {
                    resolve(0);
                    return
                }  
                const p = rList[ 0 ];
                if(p){
                    resolve(p);
                }else{
                    resolve(0);
                }
            });
        })
    }
}