const serverCode = require('./serverCode');
const {encrypt} = require('./key');
const {server} = require('./fk2Path');
const readJSON = require('./readJSON');
module.exports = (sid,arg)=>{
    var res = null;
    const data = readJSON(server);
    const time = new Date().getTime();
    if(data){
        const {key,secret} = data;
        const code = serverCode(key,secret);
        if(code){
            try {
                res = encrypt(JSON.stringify({time,sid,ip:arg.ip,code}));
            } catch (err) {
                // console.log(err);
            }
        }
    }
    return res
}