const arg = process.argv;
const fs = require('fs');
const path = require('path');
const cluster = require('cluster');
const exist = require('../plug-in/exist');
const logs = require('../plug-in/colorLog');
const url = path.join(process.cwd(),'package.json');
const paths = exist(arg[3]);
if(!paths){
    return
}
if (cluster.isMaster || cluster.isPrimary) {
    logs.g('\nFk2 Dev began to working ...\n');
    logs.g('Dev running directory is '+paths);
    logs.close();
    cluster.fork();
    cluster.on('exit', () => {
        cluster.fork();
    })
}else{
    require(paths);
    fs.watchFile(url,(cur, prv)=>{
        if (cur.mtime !== prv.mtime){
            // 文件变化
            process.exit();
        }
    })
}
