const fs = require('fs');
const path = require('path');
const logs = require('./colorLog');
module.exports = (obj) => {
    // 为省略.js和.ts 后缀
    if(!obj) return false;
    var paths = path.join(process.cwd(), obj);
    if (!fs.existsSync(paths)) {
        // 简写.js和.ts
        if (fs.existsSync(paths + '.js')) {
            paths = paths + '.js';
        } else if (fs.existsSync(paths + '.ts')) {
            paths = paths + '.ts';
        } else {
            logs.r('Can not find ' + obj + ' script!');
            logs.r('error path: ' + paths);
            logs.close();
            paths = false;
        }
    }
    return paths;
}