module.exports = (req)=>{
    // 支持ipv4 和ipv6
    var ips = req.headers['x-forwarded-for'] ||
    req.connection.remoteAddress ||
    req.socket.remoteAddress ||
    req.connection.socket.remoteAddress || '';
    var ip = ips.match(/\d+.\d+.\d+.\d+/);
    ip = ip?ip.join('.') : null;
    if(!ip.match(/^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$/)){
        return ips
    }
    return ip
}