// 设置开机启动
module.exports = (path, auto) => {
    const AutoLaunch = require('auto-launch');
    const addJSON = require('../plug-in/addJSON');
    const readJSON = require('../plug-in/readJSON');
    const { server } = require('../plug-in/fk2Path');
    var data = readJSON(server);
    if (data) {
        data.auto = auto;
    }
    const obj = new AutoLaunch({
        path,
        name: 'Fk2Run'
    });
    if (auto == true) {
        enable();
    } else {
        // disable(); //取消开机启动
    }
    function enable() {
        obj.enable().then(() => {
            // 添加成功
            if (data) {
                addJSON(server, data);
            }
        }).catch(() => {
            enable();
        });
    }
    function disable() {
        obj.disable().then(() => {
            if (data) {
                addJSON(server, data);
            }
        }).catch(() => {
            disable();
        })
    }
}