var paths =  '';
const arg = process.argv;
const cluster = require('cluster');
const exist = require('../plug-in/exist');
const logs = require('../plug-in/colorLog');
const {mainFun,wkFun,onExit,watch} = require('./workType');
if (arg[2] == 'start') {
    paths = exist(arg[3]);
    if(!paths) {
        logs.r('Command error! fk2 start xxx.js');
        return
    } 
}else{
    paths = './run';
}
if (cluster.isMaster || cluster.isPrimary) {
    /* 多少个cpu启动多少个子进程 */
    clusterMain();
    async function clusterMain() {
        if(arg[3]){
            if(arg[3]=='kill'||arg[3]=='restart'){
                const {task} = require('../plug-in/fk2Path');
                const readJSON = require('../plug-in/readJSON');
                const res = readJSON(task);
                if(res&&res.run&&res.run.ppid){
                    const {check,kill} = require('../plug-in/psNode');
                    if(await check(res.run.ppid)){
                        await kill(res.run.ppid);
                    }
                }
                if(arg[3]=='kill') return
            }
        }
        const wk = require('./worker');// 封装wk循环
        const cpu = await mainFun(); //主进程函数
        if(cpu==0) {
            // 终止开启子进程
            return
        }
        logs.g('Open clusters!');
        logs.close();
        for (let i = 0; i < cpu; i++) {
            // 时间间隔防止文件读取冲突
            setTimeout(() => {
                wk(cluster.fork());
            }, (i+1)*50);
        }
        watch(); //监听文件是否有重启动作
        /* 如果有线程退出了，我们重启一个 */
        cluster.on('exit', (obj) => {
            if(onExit(obj.process.pid)){
                wk(cluster.fork());
            }
        })
    }

} else {
    new require(paths);
    wkFun(); // 工作进程函数
    /* 心跳回应 */
    process.on('message', (msg) => {
        msg === 'goto' && process.send('back');
    })
}